rpm 5.2.1

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

Files | Typedefs | Enumerations | Functions
RPMTS Transaction Set API.
Collaboration diagram for RPMTS Transaction Set API.:

## Files
file | depends.c
file | psm.c
| Package state machine to handle a package from a transaction set.
file | rpmlib.h
| In Memoriam: Steve Taylor stayl.nosp@m.or@r.nosp@m.edhat.nosp@m..com was here, now he's not.
file | rpmte.h
| Structures used for an "rpmte" transaction element.
file | rpmts.h
| Structures and prototypes used for an "rpmts" transaction set.
file | transaction.c

## Typedefs
typedef struct rpmpsm_s * | rpmpsm
| Package state machine data. More...
typedef void * | alKey
| An added/available package retrieval key. More...
typedef int | alNum
| An added/available package retrieval index. More...
typedef pgpVSFlags | rpmVSFlags
| Bit(s) to control digest and signature verification. More...
typedef enum rpmdepFlags_e | rpmdepFlags
| Bit(s) to control rpmtsCheck() and rpmtsOrder() operation. More...
typedef enum rpmtransFlags_e | rpmtransFlags
| Bit(s) to control rpmtsRun() operation. More...
typedef enum rpmtsOpX_e | rpmtsOpX
| Indices for timestamps. More...
typedef enum rpmTSType_e | rpmTSType
| Transaction Types. More...
typedef enum tsStage_e | tsmStage
typedef struct rpmts_s * | rpmts
| The RPM Transaction Set. More...

## Enumerations
enum | rpmdepFlags_e { RPMDEPS_FLAG_NONE = 0, RPMDEPS_FLAG_NOUPGRADE = (1 << 0), RPMDEPS_FLAG_NOREQUIRES = (1 << 1), RPMDEPS_FLAG_NOCONFLICTS = (1 << 2), RPMDEPS_FLAG_NOOBSOLETES = (1 << 3), RPMDEPS_FLAG_NOPARENTDIRS = (1 << 4), RPMDEPS_FLAG_NOLINKTOS = (1 << 5), RPMDEPS_FLAG_ANACONDA = (1 << 6), RPMDEPS_FLAG_NOSUGGEST = (1 << 7), RPMDEPS_FLAG_ADDINDEPS = (1 << 8), RPMDEPS_FLAG_DEPLOOPS = (1 << 9) }
| Bit(s) to control rpmtsCheck() and rpmtsOrder() operation. More...
enum | rpmtransFlags_e { RPMTRANS_FLAG_NONE = 0, RPMTRANS_FLAG_TEST = (1 << 0), RPMTRANS_FLAG_BUILD_PROBS = (1 << 1), RPMTRANS_FLAG_NOSCRIPTS = (1 << 2), RPMTRANS_FLAG_JUSTDB = (1 << 3), RPMTRANS_FLAG_NOTRIGGERS = (1 << 4), RPMTRANS_FLAG_NODOCS = (1 << 5), RPMTRANS_FLAG_ALLFILES = (1 << 6), RPMTRANS_FLAG_NOCONTEXTS = (1 << 8), RPMTRANS_FLAG_DIRSTASH = (1 << 9), RPMTRANS_FLAG_REPACKAGE = (1 << 10), RPMTRANS_FLAG_PKGCOMMIT = (1 << 11), RPMTRANS_FLAG_PKGUNDO = (1 << 12), RPMTRANS_FLAG_COMMIT = (1 << 13), RPMTRANS_FLAG_UNDO = (1 << 14), RPMTRANS_FLAG_APPLYONLY = (1 << 25), RPMTRANS_FLAG_NOTRIGGERPREIN = (1 << 16), RPMTRANS_FLAG_NOPRE = (1 << 17), RPMTRANS_FLAG_NOPOST = (1 << 18), RPMTRANS_FLAG_NOTRIGGERIN = (1 << 19), RPMTRANS_FLAG_NOTRIGGERUN = (1 << 20), RPMTRANS_FLAG_NOPREUN = (1 << 21), RPMTRANS_FLAG_NOPOSTUN = (1 << 22), RPMTRANS_FLAG_NOTRIGGERPOSTUN = (1 << 23), RPMTRANS_FLAG_NOPAYLOAD = (1 << 24), RPMTRANS_FLAG_NORPMDB = (1 << 25), RPMTRANS_FLAG_NOFDIGESTS = (1 << 27), RPMTRANS_FLAG_NOPRETRANS = (1 << 28), RPMTRANS_FLAG_NOPOSTTRANS = (1 << 29), RPMTRANS_FLAG_NOCONFIGS = (1 << 30) }
| Bit(s) to control rpmtsRun() operation. More...
enum | rpmtsOpX_e { RPMTS_OP_TOTAL = 0, RPMTS_OP_CHECK = 1, RPMTS_OP_ORDER = 2, RPMTS_OP_FINGERPRINT = 3, RPMTS_OP_REPACKAGE = 4, RPMTS_OP_INSTALL = 5, RPMTS_OP_ERASE = 6, RPMTS_OP_SCRIPTLETS = 7, RPMTS_OP_COMPRESS = 8, RPMTS_OP_UNCOMPRESS = 9, RPMTS_OP_DIGEST = 10, RPMTS_OP_SIGNATURE = 11, RPMTS_OP_DBADD = 12, RPMTS_OP_DBREMOVE = 13, RPMTS_OP_DBGET = 14, RPMTS_OP_DBPUT = 15, RPMTS_OP_DBDEL = 16, RPMTS_OP_READHDR = 17, RPMTS_OP_HDRLOAD = 18, RPMTS_OP_HDRGET = 19, RPMTS_OP_DEBUG = 20, RPMTS_OP_MAX = 20 }
| Indices for timestamps. More...
enum | rpmTSType_e { RPMTRANS_TYPE_NORMAL = 0, RPMTRANS_TYPE_ROLLBACK = (1 << 0), RPMTRANS_TYPE_AUTOROLLBACK = (1 << 1) }
| Transaction Types. More...
enum | tsStage_e { TSM_UNKNOWN = 0, TSM_INSTALL = 7, TSM_ERASE = 8 }

## Functions
int | rpmtsCheck (rpmts ts)
| Perform dependency resolution on the transaction set. More...
int | rpmtsOrder (rpmts ts)
| Determine package order in a transaction set according to dependencies. More...
int | rpmtsRun (rpmts ts, rpmps okProbs, rpmprobFilterFlags ignoreSet)
| Process all package elements in a transaction set. More...
rpmRC | rpmtsRollback (rpmts rbts, rpmprobFilterFlags ignoreSet, int running, rpmte rbte)
| Rollback a failed transaction. More...
rpmts | rpmtsUnlink (rpmts ts, const char *msg)
| Unreference a transaction instance. More...
rpmts | rpmtsLink (rpmts ts, const char *msg)
| Reference a transaction set instance. More...
int | rpmtsCloseDB (rpmts ts)
| Close the database used by the transaction. More...
int | rpmtsOpenDB (rpmts ts, int dbmode)
| Open the database used by the transaction. More...
int | rpmtsInitDB (rpmts ts, int dbmode)
| Initialize the database used by the transaction. More...
int | rpmtsRebuildDB (rpmts ts)
| Rebuild the database used by the transaction. More...
int | rpmtsVerifyDB (rpmts ts)
| Verify the database used by the transaction. More...
rpmmi | rpmtsInitIterator (const rpmts ts, rpmTag rpmtag, const void *keyp, size_t keylen)
| Return transaction database iterator. More...
rpmRC | rpmtsFindPubkey (rpmts ts, void *_dig)
| Retrieve pubkey from rpm database. More...
int | rpmtsCloseSDB (rpmts ts)
| Close the database used by the transaction to solve dependencies. More...
int | rpmtsOpenSDB (rpmts ts, int dbmode)
| Open the database used by the transaction to solve dependencies. More...
int | rpmtsSolve (rpmts ts, rpmds ds, const void *data)
| Attempt to solve a needed dependency using the solve database. More...
int | rpmtsAvailable (rpmts ts, const rpmds ds)
| Attempt to solve a needed dependency using memory resident tables. More...
int | rpmtsSetSolveCallback (rpmts ts, int(*solve)(rpmts ts, rpmds ds, const void *data), const void *solveData)
| Set dependency solver callback. More...
rpmTSType | rpmtsType (rpmts ts)
| Return the type of a transaction. More...
void | rpmtsSetType (rpmts ts, rpmTSType type)
| Set transaction type. More...
rpmuint32_t | rpmtsARBGoal (rpmts ts)
| Return the autorollback goal. More...
void | rpmtsSetARBGoal (rpmts ts, rpmuint32_t goal)
| Set autorollback goal. More...
rpmps | rpmtsProblems (rpmts ts)
| Return current transaction set problems. More...
void | rpmtsCleanDig (rpmts ts)
| Free signature verification data. More...
void | rpmtsClean (rpmts ts)
| Free memory needed only for dependency checks and ordering. More...
void | rpmtsEmpty (rpmts ts)
| Re-create an empty transaction set. More...
rpmts | rpmtsFree (rpmts ts)
| Destroy transaction set, closing the database as well. More...
void * | rpmtsGetKeyring (rpmts ts, int autoload)
| Get transaction keyring. More...
int | rpmtsSetKeyring (rpmts ts, void *_keyring)
| Set transaction keyring. More...
rpmVSFlags | rpmtsVSFlags (rpmts ts)
| Get verify signatures flag(s). More...
rpmVSFlags | rpmtsSetVSFlags (rpmts ts, rpmVSFlags vsflags)
| Set verify signatures flag(s). More...
int | rpmtsUnorderedSuccessors (rpmts ts, int first)
| Set index of 1st element of successors. More...
const char * | rpmtsRootDir (rpmts ts)
| Get transaction rootDir, i.e. More...
void | rpmtsSetRootDir (rpmts ts, const char *rootDir)
| Set transaction rootDir, i.e. More...
const char * | rpmtsCurrDir (rpmts ts)
| Get transaction currDir, i.e. More...
void | rpmtsSetCurrDir (rpmts ts, const char *currDir)
| Set transaction currDir, i.e. More...
int | rpmtsSELinuxEnabled (rpmts ts)
| Get selinuxEnabled flag, i.e. More...
int | rpmtsChrootDone (rpmts ts)
| Get chrootDone flag, i.e. More...
int | rpmtsSetChrootDone (rpmts ts, int chrootDone)
| Set chrootDone flag, i.e. More...
rpmuint32_t | rpmtsGetTid (rpmts ts)
| Get transaction id, i.e. More...
rpmuint32_t | rpmtsSetTid (rpmts ts, rpmuint32_t tid)
| Set transaction id, i.e. More...
pgpDig | rpmtsDig (rpmts ts)
| Get OpenPGP packet parameters, i.e. More...
pgpDigParams | rpmtsPubkey (const rpmts ts)
| Return OpenPGP pubkey constants. More...
rpmdb | rpmtsGetRdb (rpmts ts)
| Get transaction set database handle. More...
rpmPRCO | rpmtsPRCO (rpmts ts)
| Get transaction set dependencies. More...
int | rpmtsInitDSI (const rpmts ts)
| Initialize disk space info for each and every mounted file systems. More...
void | rpmtsUpdateDSI (const rpmts ts, dev_t dev, rpmuint32_t fileSize, rpmuint32_t prevSize, rpmuint32_t fixupSize, int _action)
| Update disk space info for a file. More...
void | rpmtsCheckDSIProblems (const rpmts ts, const rpmte te)
| Check a transaction element for disk space problems. More...
void * | rpmtsNotify (rpmts ts, rpmte te, rpmCallbackType what, rpmuint64_t amount, rpmuint64_t total)
| Perform transaction progress notify callback. More...
int | rpmtsNElements (rpmts ts)
| Return number of (ordered) transaction set elements. More...
rpmte | rpmtsElement (rpmts ts, int ix)
| Return (ordered) transaction set element. More...
rpmprobFilterFlags | rpmtsFilterFlags (rpmts ts)
| Get problem ignore bit mask, i.e. More...
rpmtransFlags | rpmtsFlags (rpmts ts)
| Get transaction flags, i.e. More...
rpmtransFlags | rpmtsSetFlags (rpmts ts, rpmtransFlags transFlags)
| Set transaction flags, i.e. More...
rpmdepFlags | rpmtsDFlags (rpmts ts)
| Get dependency flags, i.e. More...
rpmdepFlags | rpmtsSetDFlags (rpmts ts, rpmdepFlags depFlags)
| Set dependency flags, i.e. More...
Spec | rpmtsSpec (rpmts ts)
| Get spec control structure from transaction set. More...
Spec | rpmtsSetSpec (rpmts ts, Spec spec)
| Set a spec control structure in transaction set. More...
rpmte | rpmtsRelocateElement (rpmts ts)
| Get current relocate transaction element. More...
rpmte | rpmtsSetRelocateElement (rpmts ts, rpmte relocateElement)
| Set current relocate transaction element. More...
tsmStage | rpmtsGoal (rpmts ts)
| Retrieve goal of transaction set. More...
tsmStage | rpmtsSetGoal (rpmts ts, tsmStage goal)
| Set goal of transaction set. More...
int | rpmtsDBMode (rpmts ts)
| Retrieve dbmode of transaction set. More...
int | rpmtsSetDBMode (rpmts ts, int dbmode)
| Set dbmode of transaction set. More...
rpmuint32_t | rpmtsColor (rpmts ts)
| Retrieve color bits of transaction set. More...
rpmuint32_t | rpmtsPrefColor (rpmts ts)
| Retrieve prefered file color. More...
rpmuint32_t | rpmtsSetColor (rpmts ts, rpmuint32_t color)
| Set color bits of transaction set. More...
rpmop | rpmtsOp (rpmts ts, rpmtsOpX opx)
| Retrieve operation timestamp from a transaction set. More...
int | rpmtsSetNotifyCallback (rpmts ts, rpmCallbackFunction notify, rpmCallbackData notifyData)
| Set transaction notify callback function and argument. More...
rpmts | rpmtsCreate (void)
| Create an empty transaction set. More...
int | rpmtsAddInstallElement (rpmts ts, Header h, const fnpyKey key, int upgrade, rpmRelocation relocs)
| Add package to be installed to transaction set. More...
int | rpmtsAddEraseElement (rpmts ts, Header h, int dboffset)
| Add package to be erased to transaction set. More...

## Detailed Description

## Typedef Documentation

typedef void* alKey

An added/available package retrieval key.

Definition at line 19 of file rpmal.h.

typedef int alNum

An added/available package retrieval index.

Definition at line 26 of file rpmal.h.

typedef enum rpmdepFlags_e rpmdepFlags

Bit(s) to control rpmtsCheck() and rpmtsOrder() operation.

Todo:
  Move to rpmts.h.

typedef struct rpmpsm_s* rpmpsm

Package state machine data.

Definition at line 13 of file psm.h.

typedef enum rpmtransFlags_e rpmtransFlags

Bit(s) to control rpmtsRun() operation.

Todo:
  Move to rpmts.h.

typedef struct rpmts_s* rpmts

The RPM Transaction Set.

Transaction sets are inherently unordered! RPM may reorder transaction sets to reduce errors. In general, installs/upgrades are done before strict removals, and prerequisite ordering is done on installs/upgrades.

Definition at line 14 of file rpmtypes.h.

typedef enum rpmtsOpX_e rpmtsOpX

Indices for timestamps.

typedef enum rpmTSType_e rpmTSType

Transaction Types.

typedef pgpVSFlags rpmVSFlags

Bit(s) to control digest and signature verification.

Definition at line 28 of file rpmts.h.

typedef enum tsStage_e tsmStage

## Enumeration Type Documentation

enum rpmdepFlags_e

Bit(s) to control rpmtsCheck() and rpmtsOrder() operation.

Todo:
  Move to rpmts.h.

Enumerator
RPMDEPS_FLAG_NONE |
RPMDEPS_FLAG_NOUPGRADE | from –noupgrade
RPMDEPS_FLAG_NOREQUIRES | from –norequires
RPMDEPS_FLAG_NOCONFLICTS | from –noconflicts
RPMDEPS_FLAG_NOOBSOLETES | from –noobsoletes
RPMDEPS_FLAG_NOPARENTDIRS | from –noparentdirs
RPMDEPS_FLAG_NOLINKTOS | from –nolinktos
RPMDEPS_FLAG_ANACONDA | from –anaconda
RPMDEPS_FLAG_NOSUGGEST | from –nosuggest
RPMDEPS_FLAG_ADDINDEPS | from –aid
RPMDEPS_FLAG_DEPLOOPS | from –deploops

Definition at line 34 of file rpmts.h.

enum rpmtransFlags_e

Bit(s) to control rpmtsRun() operation.

Todo:
  Move to rpmts.h.

Enumerator
RPMTRANS_FLAG_NONE |
RPMTRANS_FLAG_TEST | from –test
RPMTRANS_FLAG_BUILD_PROBS | don't process payload
RPMTRANS_FLAG_NOSCRIPTS | from –noscripts
RPMTRANS_FLAG_JUSTDB | from –justdb
RPMTRANS_FLAG_NOTRIGGERS | from –notriggers
RPMTRANS_FLAG_NODOCS | from –excludedocs
RPMTRANS_FLAG_ALLFILES | from –allfiles
RPMTRANS_FLAG_NOCONTEXTS | from –nocontexts
RPMTRANS_FLAG_DIRSTASH | from –dirstash
RPMTRANS_FLAG_REPACKAGE | from –repackage
RPMTRANS_FLAG_PKGCOMMIT |
RPMTRANS_FLAG_PKGUNDO |
RPMTRANS_FLAG_COMMIT |
RPMTRANS_FLAG_UNDO |
RPMTRANS_FLAG_APPLYONLY |
RPMTRANS_FLAG_NOTRIGGERPREIN | from –notriggerprein
RPMTRANS_FLAG_NOPRE | from –nopre
RPMTRANS_FLAG_NOPOST | from –nopost
RPMTRANS_FLAG_NOTRIGGERIN | from –notriggerin
RPMTRANS_FLAG_NOTRIGGERUN | from –notriggerun
RPMTRANS_FLAG_NOPREUN | from –nopreun
RPMTRANS_FLAG_NOPOSTUN | from –nopostun
RPMTRANS_FLAG_NOTRIGGERPOSTUN | from –notriggerpostun
RPMTRANS_FLAG_NOPAYLOAD |
RPMTRANS_FLAG_NORPMDB | from –norpmdb
RPMTRANS_FLAG_NOFDIGESTS | from –nofdigests
RPMTRANS_FLAG_NOPRETRANS | from –nopretrans
RPMTRANS_FLAG_NOPOSTTRANS | from –noposttrans
RPMTRANS_FLAG_NOCONFIGS | from –noconfigs

Definition at line 52 of file rpmts.h.

enum rpmtsOpX_e

Indices for timestamps.

Enumerator
RPMTS_OP_TOTAL |
RPMTS_OP_CHECK |
RPMTS_OP_ORDER |
RPMTS_OP_FINGERPRINT |
RPMTS_OP_REPACKAGE |
RPMTS_OP_INSTALL |
RPMTS_OP_ERASE |
RPMTS_OP_SCRIPTLETS |
RPMTS_OP_COMPRESS |
RPMTS_OP_UNCOMPRESS |
RPMTS_OP_DIGEST |
RPMTS_OP_SIGNATURE |
RPMTS_OP_DBADD |
RPMTS_OP_DBREMOVE |
RPMTS_OP_DBGET |
RPMTS_OP_DBPUT |
RPMTS_OP_DBDEL |
RPMTS_OP_READHDR |
RPMTS_OP_HDRLOAD |
RPMTS_OP_HDRGET |
RPMTS_OP_DEBUG |
RPMTS_OP_MAX |

Definition at line 115 of file rpmts.h.

enum rpmTSType_e

Transaction Types.

Enumerator
RPMTRANS_TYPE_NORMAL |
RPMTRANS_TYPE_ROLLBACK |
RPMTRANS_TYPE_AUTOROLLBACK |

Definition at line 143 of file rpmts.h.

enum tsStage_e

Enumerator
TSM_UNKNOWN |
TSM_INSTALL |
TSM_ERASE |

Definition at line 151 of file rpmts.h.

## Function Documentation

int rpmtsAddEraseElement | ( | rpmts | ts,
|  | Header | h,
|  | int | dboffset
| ) |  |

Add package to be erased to transaction set.

Parameters

  ts | transaction set
  h | header
  dboffset | rpm database instance

Returns
  0 on success

Definition at line 806 of file depends.c.

References removePackage(), RPMAL_NOMATCH, and rpmtsEraseDebuginfo().

Referenced by findErases(), rpmcliEraseElement(), rpmErase(), rpmgiNext(), rpmts_AddErase(), and verifyDependencies().

int rpmtsAddInstallElement | ( | rpmts | ts,
|  | Header | h,
|  | const fnpyKey | key,
|  | int | upgrade,
|  | rpmRelocation | relocs
| ) |  |

Add package to be installed to transaction set.

The transaction set is checked for duplicate package names. If found, the package with the "newest" EVR will be replaced.

Parameters

  ts | transaction set
  h | header
  key | package retrieval key (e.g. file name)
  upgrade | is package being upgraded?
  relocs | package file relocations

Returns
  0 on success, 1 on I/O error, 2 needs capabilities

Definition at line 546 of file depends.c.

References _, _free(), alloca(), chkSuffix(), headerGet(), headerIsEntry(), hGetColor(), nplatpat, _HE_s::p, platform, platpat, rpmDataType_u::ptr, RPMAL_NOMATCH, rpmalAdd(), rpmcliPackagesTotal, RPMDEPS_FLAG_NOOBSOLETES, RPMDEPS_FLAG_NOUPGRADE, rpmdsCompare(), rpmdsDNEVR(), rpmdsFree(), rpmdsThis(), rpmExpand(), rpmIsVerbose, rpmlog(), RPMLOG_WARNING, rpmPlatformScore(), RPMPROB_BADPLATFORM, rpmProblemString(), rpmpsAppend(), rpmpsFree(), rpmpsGetProblem(), RPMSENSE_EQUAL, RPMSENSE_GREATER, RPMSENSE_LESS, RPMTAG_ARCH, RPMTAG_BASENAMES, RPMTAG_NAME, RPMTAG_NVRA, RPMTAG_OS, RPMTAG_PLATFORM, RPMTAG_PROVIDENAME, RPMTAG_REQUIRENAME, RPMTAG_SOURCERPM, rpmteA(), rpmteAddedKey(), rpmteDS(), rpmteFI(), rpmteIsSource(), rpmteKey(), rpmteN(), rpmteNew(), rpmteO(), rpmteSetAddedKey(), rpmteSetHeader(), rpmteType(), rpmtsAddObsoletes(), rpmtsAddUpgrades(), rpmtsColor(), rpmtsDBMode(), rpmtsDFlags(), rpmtsEraseDebuginfo(), rpmtsGetRdb(), rpmtsiFree(), rpmtsiInit(), rpmtsiNext(), rpmtsOpenDB(), rpmtsProblems(), rpmDataType_u::str, _HE_s::tag, TR_ADDED, TR_REMOVED, and xrealloc().

Referenced by rpmcliInstall(), rpmgiNext(), rpmInstallSourcePackage(), rpmRollback(), rpmts_AddInstall(), rpmtsSolve(), and verifyDependencies().

rpmuint32_t rpmtsARBGoal | ( | rpmts | ts | ) |

Return the autorollback goal.

Parameters

  ts | transaction set

Returns
  autorollback goal

Definition at line 795 of file rpmts.c.

Referenced by rpmtsRollback().

int rpmtsAvailable | ( | rpmts | ts,
|  | const rpmds | ds
| ) |  |

Attempt to solve a needed dependency using memory resident tables.

Deprecated:
  This function will move from rpmlib to the python bindings.

Parameters

  ts | transaction set
  ds | dependency set

Returns
  0 if resolved (and added to ts), 1 not found

Definition at line 462 of file rpmts.c.

References _free(), rpmalAllSatisfiesDepend(), and xrealloc().

int rpmtsCheck | ( | rpmts | ts | ) |

Perform dependency resolution on the transaction set.

Any problems found by rpmtsCheck() can be examined by retrieving the problem set with rpmtsProblems(), success here only means that the resolution was successfully attempted for all packages in the set.

Parameters

  ts | transaction set

Returns
  0 = deps ok, 1 = dep problems, 2 = error

Definition at line 2789 of file depends.c.

References _free(), checkDependentConflicts(), checkDependentPackages(), checkPackageDeps(), L, rpmalMakeIndex(), rpmdbCloseDBI(), RPMDBI_DEPENDS, RPMDEPS_FLAG_NOCONFLICTS, RPMDEPS_FLAG_NOLINKTOS, RPMDEPS_FLAG_NOPARENTDIRS, RPMDEPS_FLAG_NOREQUIRES, rpmdsEVR(), rpmdsFromPRCO(), rpmdsInit(), rpmdsN(), rpmdsNegateRC(), rpmdsNext(), rpmdsNSType(), rpmfiFN(), rpmfiInit(), rpmfiNext(), rpmlog(), RPMLOG_DEBUG, rpmmiFree(), RPMNS_TYPE_ENVVAR, RPMPROB_FILTER_NONE, rpmpsFree(), rpmpsNumProblems(), rpmswEnter(), rpmswExit(), RPMTAG_BASENAMES, RPMTAG_CONFLICTNAME, RPMTAG_DIRNAMES, RPMTAG_FILELINKTOS, RPMTAG_PROVIDENAME, RPMTAG_REQUIRENAME, rpmteA(), rpmteColor(), rpmteDS(), rpmteFI(), rpmteNEVR(), rpmteNEVRA(), rpmteO(), RPMTS_OP_CHECK, rpmtsCloseDB(), rpmtsColor(), rpmtsDBMode(), rpmtsDFlags(), rpmtsGetRdb(), rpmtsiFree(), rpmtsiInit(), rpmtsiNext(), rpmtsOp(), rpmtsOpenDB(), rpmtsPRCO(), rpmtsProblems(), rpmtsRollback(), TR_ADDED, TR_REMOVED, and xstrdup().

Referenced by rpmcliInstallCheck(), rpmgiNext(), rpmts_Check(), and verifyDependencies().

void rpmtsCheckDSIProblems | ( | const rpmts | ts,
|  | const rpmte | te
| ) |  |

Check a transaction element for disk space problems.

Parameters

  ts | transaction set
  te | current transaction element

Definition at line 1145 of file rpmts.c.

References rpmfiFC(), RPMPROB_DISKNODES, RPMPROB_DISKSPACE, RPMPROB_RDONLY, rpmpsAppend(), rpmpsFree(), RPMTAG_BASENAMES, rpmteFI(), rpmteKey(), rpmteNEVR(), rpmtsProblems(), and ST_RDONLY.

Referenced by rpmtsRun().

int rpmtsChrootDone | ( | rpmts | ts | ) |

Get chrootDone flag, i.e.

has chroot(2) been performed?

Parameters

  ts | transaction set

Returns
  chrootDone flag

Definition at line 920 of file rpmts.c.

Referenced by rpmpsmStage(), rpmtsRun(), and runScript().

void rpmtsClean | ( | rpmts | ts | ) |

Free memory needed only for dependency checks and ordering.

Parameters

  ts | transaction set

Definition at line 517 of file rpmts.c.

References _free(), rpmalFree(), rpmpsFree(), rpmteCleanDS(), rpmtsCleanDig(), rpmtsiFree(), rpmtsiInit(), and rpmtsiNext().

Referenced by rpmcliImportPubkeys(), rpmcliInstall(), rpmErase(), rpmInstallSourcePackage(), rpmRollback(), rpmts_Clean(), rpmtsEmpty(), and rpmtsOrder().

void rpmtsCleanDig | ( | rpmts | ts | ) |

Free signature verification data.

Parameters

  ts | transaction set

Definition at line 361 of file pkgio.c.

References pgpDigFree(), pgpStatsAccumulator(), rpmswAdd(), RPMTS_OP_DIGEST, RPMTS_OP_SIGNATURE, and rpmtsOp().

Referenced by miFreeHeader(), rpmdbAdd(), rpmmiNext(), rpmnsProbeSignature(), rpmReadPackageFile(), rpmtsClean(), and rpmVerifySignatures().

int rpmtsCloseDB | ( | rpmts | ts | ) |

Close the database used by the transaction.

Parameters

  ts | transaction set

Returns
  0 on success

Definition at line 91 of file rpmts.c.

References rpmdbClose(), rpmswAdd(), RPMTS_OP_DBDEL, RPMTS_OP_DBGET, RPMTS_OP_DBPUT, and rpmtsOp().

Referenced by ftsCacheUpdate(), rpmts_CloseDB(), rpmts_InitDB(), rpmtsCheck(), rpmtsFini(), and rpmtsOpenDB().

int rpmtsCloseSDB | ( | rpmts | ts | ) |

Close the database used by the transaction to solve dependencies.

Parameters

  ts | transaction set

Returns
  0 on success

Definition at line 242 of file rpmts.c.

References rpmdbClose(), rpmswAdd(), RPMTS_OP_DBDEL, RPMTS_OP_DBGET, RPMTS_OP_DBPUT, and rpmtsOp().

Referenced by rpmtsFini().

rpmuint32_t rpmtsColor | ( | rpmts | ts | ) |

Retrieve color bits of transaction set.

Parameters

  ts | transaction set

Returns
  color bits

Definition at line 1345 of file rpmts.c.

Referenced by checkPackageSet(), handleInstInstalledFiles(), handleOverlappedFiles(), populateInstallHeader(), rpmpsmStage(), rpmtsAddInstallElement(), rpmtsAddObsoletes(), rpmtsAddUpgrades(), rpmtsCheck(), rpmtsOrder(), rpmtsRun(), and skipFiles().

rpmts rpmtsCreate | ( | void |  | ) |

Create an empty transaction set.

Returns
  new transaction set

Definition at line 1375 of file rpmts.c.

References is_selinux_enabled, rpmExpandNumeric(), rpmswEnter(), RPMTRANS_TYPE_NORMAL, RPMTS_OP_TOTAL, rpmtsGetPool(), rpmtsLink(), rpmtsOp(), rpmtsSolve(), TSM_UNKNOWN, and xcalloc().

Referenced by cpio_doio(), main(), and rpmts_new().

const char* rpmtsCurrDir | ( | rpmts | ts | ) |

Get transaction currDir, i.e.

current directory before chroot(2).

Parameters

  ts | transaction set

Returns
  transaction currDir

Definition at line 866 of file rpmts.c.

Referenced by rpmpsmStage(), and rpmtsRun().

int rpmtsDBMode | ( | rpmts | ts | ) |

Retrieve dbmode of transaction set.

Parameters

  ts | transaction set

Returns
  dbmode

Definition at line 1330 of file rpmts.c.

Referenced by rpmts_OpenDB(), rpmtsAddInstallElement(), and rpmtsCheck().

rpmdepFlags rpmtsDFlags | ( | rpmts | ts | ) |

Get dependency flags, i.e.

bits that control rpmtsCheck() and rpmtsOrder().

Parameters

  ts | transaction set

Returns
  dependency flags

Definition at line 1268 of file rpmts.c.

Referenced by checkPackageSet(), ignoreDep(), rpmgiNext(), rpmtsAddInstallElement(), rpmtsCheck(), rpmtsOrder(), rpmtsRollback(), and unsatisfiedDepend().

pgpDig rpmtsDig | ( | rpmts | ts | ) |

Get OpenPGP packet parameters, i.e.

signature/pubkey constants.

Parameters

  ts | transaction set

Returns
  signature/pubkey constants.

Definition at line 346 of file pkgio.c.

References pgpDigNew(), pgpSetFindPubkey(), and rpmtsFindPubkey().

Referenced by miFreeHeader(), rpmdbAdd(), rpmmiNext(), rpmnsProbeSignature(), rpmReadPackageFile(), rpmtsFindPubkey(), rpmtsPubkey(), and rpmVerifySignatures().

rpmte rpmtsElement | ( | rpmts | ts,
|  | int | ix
| ) |  |

Return (ordered) transaction set element.

Parameters

  ts | transaction set
  ix | transaction element index

Returns
  transaction element (or NULL)

Definition at line 1224 of file rpmts.c.

Referenced by rpmInstallSourcePackage(), rpmtsiFi(), and rpmtsiNextElement().

void rpmtsEmpty | ( | rpmts | ts | ) |

Re-create an empty transaction set.

Parameters

  ts | transaction set

Definition at line 544 of file rpmts.c.

References rpmtsClean(), rpmtsiFree(), rpmtsiInit(), and rpmtsiNext().

Referenced by rpmcliArgIter(), rpmcliInstall(), rpmcliVerify(), rpmErase(), rpmRollback(), rpmtsFini(), rpmtsRollback(), and verifyDependencies().

rpmprobFilterFlags rpmtsFilterFlags | ( | rpmts | ts | ) |

Get problem ignore bit mask, i.e.

bits to filter encountered problems.

Parameters

  ts | transaction set

Returns
  ignore bit mask

Definition at line 1236 of file rpmts.c.

Referenced by handleOverlappedFiles(), relocateFileList(), rpmtsInitDSI(), and rpmtsRun().

rpmRC rpmtsFindPubkey | ( | rpmts | ts,
|  | void * | _dig
| ) |  |

Retrieve pubkey from rpm database.

Parameters

  ts | rpm transaction
  _dig | container (NULL uses rpmtsDig(ts) instead).

Returns
  RPMRC_OK on success, RPMRC_NOKEY if not found

Definition at line 157 of file pkgio.c.

References _, _free(), alloca(), rpmDataType_u::argv, _HE_s::c, headerGet(), _HE_s::p, PGPARMOR_PUBKEY, pgpGetPubkey(), pgpGetSignature(), pgpGrab(), pgpHexStr(), pgpPrtPkts(), PGPPUBKEYALGO_DSA, PGPPUBKEYALGO_RSA, pgpReadPkts(), rpmDataType_u::ptr, rpmdbOpen(), rpmExpand(), rpmGetPath(), rpmiobNew(), rpmkuFindPubkey(), rpmkuStorePubkey(), rpmlog(), RPMLOG_DEBUG, RPMLOG_ERR, rpmmiFilenum(), rpmmiFree(), rpmmiInit(), rpmmiInstance(), rpmmiNext(), RPMRC_FAIL, RPMRC_NOKEY, RPMRC_NOTFOUND, RPMRC_NOTTRUSTED, RPMRC_OK, RPMTAG_PUBKEYS, rpmtsDig(), rpmtsGetRdb(), _HE_s::tag, xmalloc(), and xstrdup().

Referenced by rpmtsDig().

rpmtransFlags rpmtsFlags | ( | rpmts | ts | ) |

Get transaction flags, i.e.

bits that control rpmtsRun().

Parameters

  ts | transaction set

Returns
  transaction flags

Definition at line 1241 of file rpmts.c.

References RPMTRANS_FLAG_NOCONTEXTS, and rpmtsSELinuxEnabled().

Referenced by fsmSetup(), handleInstInstalledFiles(), iosmSetup(), rpmpsmStage(), rpmtsRollback(), rpmtsRun(), and skipFiles().

rpmts rpmtsFree | ( | rpmts | ts | ) |

Destroy transaction set, closing the database as well.

Parameters

  ts | transaction set

Returns
  NULL on last dereference

Referenced by cpio_doio(), fsmTeardown(), iosmTeardown(), main(), mapFreeIterator(), rpmgiFini(), rpmInstallSourcePackage(), rpmpsmFini(), rpmts_dealloc(), rpmts_free(), and rpmtsiFini().

void* rpmtsGetKeyring | ( | rpmts | ts,
|  | int | autoload
| ) |  |

Get transaction keyring.

Parameters

  ts | transaction set
  autoload | Should keyring be loaded? (unimplmented)

Returns
  transaction keyring

Definition at line 706 of file rpmts.c.

rpmdb rpmtsGetRdb | ( | rpmts | ts | ) |

Get transaction set database handle.

Parameters

  ts | transaction set

Returns
  transaction database handle

Definition at line 146 of file pkgio.c.

Referenced by checkDependentConflicts(), checkDependentPackages(), ftsCacheUpdate(), handleOneTrigger(), rpmcliImportPubkey(), rpmdbTriggerGlobs(), rpmgiNext(), rpmpsmStage(), rpmts_dealloc(), rpmts_free(), rpmts_Match(), rpmts_new(), rpmtsAddInstallElement(), rpmtsCheck(), rpmtsFindPubkey(), rpmtsRollback(), rpmtsRun(), rpmtsSetKeyring(), runImmedTriggers(), runTriggers(), and unsatisfiedDepend().

rpmuint32_t rpmtsGetTid | ( | rpmts | ts | ) |

Get transaction id, i.e.

transaction time stamp.

Parameters

  ts | transaction set

Returns
  transaction id

Definition at line 937 of file rpmts.c.

Referenced by fsmSetup(), ftsCacheUpdate(), iosmSetup(), rpmcliImportPubkey(), rpmpsmStage(), and rpmtsRollback().

tsmStage rpmtsGoal | ( | rpmts | ts | ) |

Retrieve goal of transaction set.

Parameters

  ts | transaction set

Returns
  goal

Definition at line 1315 of file rpmts.c.

References TSM_UNKNOWN.

int rpmtsInitDB | ( | rpmts | ts,
|  | int | dbmode
| ) |  |

Initialize the database used by the transaction.

Deprecated:
  An explicit rpmdbInit() is almost never needed.

Parameters

  ts | transaction set
  dbmode | O_RDONLY or O_RDWR

Returns
  0 on success

Definition at line 128 of file rpmts.c.

References rpmdbInit().

Referenced by main(), and rpmts_InitDB().

int rpmtsInitDSI | ( | const rpmts | ts | ) |

Initialize disk space info for each and every mounted file systems.

Parameters

  ts | transaction set

Returns
  0 on success

Definition at line 980 of file rpmts.c.

References _free(), D_, rpmGetFilesystemList(), rpmlog(), RPMLOG_DEBUG, RPMPROB_FILTER_DISKSPACE, rpmtsFilterFlags(), ST_RDONLY, and xcalloc().

Referenced by rpmtsRun(), and unsatisfiedDepend().

rpmmi rpmtsInitIterator | ( | const rpmts | ts,
|  | rpmTag | rpmtag,
|  | const void * | keyp,
|  | size_t | keylen
| ) |  |

Return transaction database iterator.

Parameters

  ts | transaction set
  rpmtag | rpm tag
  keyp | key data (NULL for sequential access)
  keylen | key data length (0 will use strlen(keyp))

Returns
  NULL on failure

Definition at line 162 of file rpmts.c.

References _, alloca(), RPMDBI_LABEL, rpmlog(), RPMLOG_ERR, rpmmiAddPattern(), rpmmiInit(), RPMMIRE_DEFAULT, rpmmiSetHdrChk(), rpmnsArch(), RPMTAG_ARCH, rpmtsOpenDB(), rpmtsVSFlags(), RPMVSF_NOHDRCHK, and xisdigit().

Referenced by checkDependentConflicts(), checkDependentPackages(), ftsCacheUpdate(), handleInstInstalledFiles(), handleRmvdInstalledFiles(), IDTXload(), markReplacedFiles(), rpmcliEraseElement(), rpmcliInstall(), rpmErase(), rpmgiInitFilter(), rpmpsmStage(), rpmQueryVerify(), rpmts_AddErase(), rpmts_Match(), rpmtsAddObsoletes(), rpmtsAddUpgrades(), rpmtsEraseDebuginfo(), rpmtsRun(), runImmedTriggers(), runTriggersLoop(), and unsatisfiedDepend().

rpmts rpmtsLink | ( | rpmts | ts,
|  | const char * | msg
| ) |  |

Reference a transaction set instance.

Parameters

  ts | transaction set
  msg |

Returns
  new transaction set reference

Referenced by fsmSetup(), iosmSetup(), rpmgiNew(), rpmInstallSourcePackage(), rpmpsmNew(), rpmtsCreate(), and XrpmtsiInit().

int rpmtsNElements | ( | rpmts | ts | ) |

Return number of (ordered) transaction set elements.

Parameters

  ts | transaction set

Returns
  no. of transaction set elements

Definition at line 1215 of file rpmts.c.

Referenced by rpmcliInstall(), rpmtsiNextElement(), rpmtsRun(), and XrpmtsiInit().

void* rpmtsNotify | ( | rpmts | ts,
|  | rpmte | te,
|  | rpmCallbackType | what,
|  | rpmuint64_t | amount,
|  | rpmuint64_t | total
| ) |  |

Perform transaction progress notify callback.

Warning
  This function's args have changed, so the function cannot be used portably

Parameters

  ts | transaction set
  te | current transaction element
  what | type of call back
  amount | current value
  total | final value

Returns
  callback dependent pointer

Definition at line 1188 of file rpmts.c.

References headerFree(), headerLink(), and rpmteKey().

Referenced by fsmSetup(), fsmStage(), iosmSetup(), iosmStage(), rpmpsmStage(), rpmtsRun(), and runScript().

rpmop rpmtsOp | ( | rpmts | ts,
|  | rpmtsOpX | opx
| ) |  |

Retrieve operation timestamp from a transaction set.

Parameters

  ts | transaction set
  opx | operation timestamp index

Returns
  pointer to operation timestamp.

Definition at line 128 of file pkgio.c.

References RPMTS_OP_MAX.

Referenced by fsmTeardown(), iosmTeardown(), psmWait(), repoFclose(), repoRfileDigest(), rpmpsmStage(), rpmReadPackageFile(), rpmtsCheck(), rpmtsCleanDig(), rpmtsCloseDB(), rpmtsCloseSDB(), rpmtsCreate(), rpmtsOrder(), rpmtsPrintStats(), and rpmtsRun().

int rpmtsOpenDB | ( | rpmts | ts,
|  | int | dbmode
| ) |  |

Open the database used by the transaction.

Parameters

  ts | transaction set
  dbmode | O_RDONLY or O_RDWR

Returns
  0 on success

Definition at line 105 of file rpmts.c.

References _, _free(), rpmdbOpen(), rpmGetPath(), rpmlog(), RPMLOG_ERR, and rpmtsCloseDB().

Referenced by ftsCacheUpdate(), rpmcliImportPubkey(), rpmts_Match(), rpmts_OpenDB(), rpmtsAddInstallElement(), rpmtsCheck(), rpmtsInitIterator(), rpmtsRebuildDB(), rpmtsRollback(), and rpmtsRun().

int rpmtsOpenSDB | ( | rpmts | ts,
|  | int | dbmode
| ) |  |

Open the database used by the transaction to solve dependencies.

Parameters

  ts | transaction set
  dbmode | O_RDONLY or O_RDWR

Returns
  0 on success

Definition at line 256 of file rpmts.c.

References _, _free(), addMacro(), delMacro(), RMIL_DEFAULT, rpmdbOpen(), rpmExpandNumeric(), rpmGetPath(), rpmlog(), and RPMLOG_WARNING.

Referenced by rpmtsSolve().

int rpmtsOrder | ( | rpmts | ts | ) |

Determine package order in a transaction set according to dependencies.

Order packages, returning error if circular dependencies cannot be eliminated by removing Requires's from the loop(s). Only dependencies from added or removed packages are used to determine ordering using a topological sort (Knuth vol. 1, p. 262). Use rpmtsCheck() to verify that all dependencies can be resolved.

The final order ends up as installed packages followed by removed packages, with packages removed for upgrades immediately following the new package to be installed.

Parameters

  ts | transaction set

Returns
  no. of (added) packages that could not be ordered

Definition at line 2290 of file depends.c.

References _, _free(), addQ(), addRelation(), alloca(), countSlashes(), D_, freeBadDeps(), isAuto, markLoop(), orderListIndexCmp(), orderListIndex_s::orIndex, orderListIndex_s::pkgKey, RPMAL_NOMATCH, rpmalAdd(), rpmalMakeIndex(), RPMDEPS_FLAG_ANACONDA, RPMDEPS_FLAG_DEPLOOPS, rpmdsFlags(), rpmdsFromPRCO(), rpmdsInit(), rpmdsN(), rpmdsNext(), rpmExpandNumeric(), rpmlog(), RPMLOG_DEBUG, RPMLOG_ERR, RPMLOG_WARNING, RPMPROB_FILTER_NONE, rpmswEnter(), rpmswExit(), RPMTAG_BASENAMES, RPMTAG_DIRNAMES, RPMTAG_FILELINKTOS, RPMTAG_NAME, RPMTAG_PROVIDENAME, RPMTAG_REQUIRENAME, rpmteAddedKey(), rpmteDegree(), rpmteDepth(), rpmteDS(), rpmteFI(), rpmteFreeTSI(), rpmteNEVRA(), rpmteNewTSI(), rpmteNpreds(), rpmtePkgFileSize(), rpmteSetAddedKey(), rpmteSetBreadth(), rpmteSetDegree(), rpmteSetDepth(), rpmteSetNpreds(), rpmteSetParent(), rpmteSetTree(), rpmteTree(), rpmteTSI(), rpmteType(), RPMTS_OP_ORDER, rpmtsClean(), rpmtsColor(), rpmtsDFlags(), rpmtsiFree(), rpmtsiInit(), rpmtsiNext(), rpmtsiOc(), rpmtsOp(), rpmtsPrefColor(), rpmtsRollback(), rpmtsUnorderedSuccessors(), TR_ADDED, TR_REMOVED, xcalloc(), and zapRelation().

Referenced by rpmcliInstallOrder(), rpmgiNew(), and rpmts_Order().

rpmPRCO rpmtsPRCO | ( | rpmts | ts | ) |

Get transaction set dependencies.

Parameters

  ts | transaction set

Returns
  transaction set dependencies.

Definition at line 957 of file rpmts.c.

References _free(), R_OK, rpmdsNewPRCO(), rpmdsSysinfo(), rpmGetPath(), and rpmioAccess().

Referenced by rpmtsCheck(), and unsatisfiedDepend().

rpmuint32_t rpmtsPrefColor | ( | rpmts | ts | ) |

Retrieve prefered file color.

Parameters

  ts | transaction set

Returns
  color bits

Definition at line 1360 of file rpmts.c.

Referenced by handleInstInstalledFiles(), handleOverlappedFiles(), and rpmtsOrder().

rpmps rpmtsProblems | ( | rpmts | ts | ) |

Return current transaction set problems.

Parameters

  ts | transaction set

Returns
  current problem set (or NULL)

Definition at line 503 of file rpmts.c.

References rpmpsCreate(), and rpmpsLink().

Referenced by checkPackageDeps(), cmpArgvStr(), ensureOlder(), handleInstInstalledFiles(), handleOverlappedFiles(), relocateFileList(), rpmcliInstallProblems(), rpmgiNext(), rpmts_Check(), rpmts_Problems(), rpmts_Run(), rpmtsAddInstallElement(), rpmtsCheck(), rpmtsCheckDSIProblems(), rpmtsRun(), and verifyDependencies().

pgpDigParams rpmtsPubkey | ( | const rpmts | ts | ) |

Return OpenPGP pubkey constants.

Parameters

  ts | transaction set

Returns
  pubkey constants.

Definition at line 139 of file pkgio.c.

References pgpGetPubkey(), and rpmtsDig().

int rpmtsRebuildDB | ( | rpmts | ts | ) |

Rebuild the database used by the transaction.

Parameters

  ts | transaction set

Returns
  0 on success

Definition at line 140 of file rpmts.c.

References rpmdbRebuild(), rpmtsOpenDB(), rpmtsVSFlags(), and RPMVSF_NOHDRCHK.

Referenced by main(), and rpmts_RebuildDB().

rpmte rpmtsRelocateElement | ( | rpmts | ts | ) |

Get current relocate transaction element.

Parameters

  ts | transaction set

Returns
  current relocate transaction element

Definition at line 1299 of file rpmts.c.

Referenced by relocateFileList(), and rpmfiNew().

rpmRC rpmtsRollback | ( | rpmts | rbts,
|  | rpmprobFilterFlags | ignoreSet,
|  | int | running,
|  | rpmte | rbte
| ) |  |

Rollback a failed transaction.

Parameters

  rbts | failed transaction set
  ignoreSet | problems to ignore
  running | partial transaction?
  rbte | failed transaction element

Returns
  RPMRC_OK, or RPMRC_FAIL

Definition at line 980 of file transaction.c.

References _, _free(), _processFailedPackage(), _RPMVSF_NODIGESTS, _RPMVSF_NOSIGNATURES, alloca(), rpmQVKArguments_s::depFlags, Fclose(), Fopen(), INSTALL_HASH, INSTALL_UPGRADE, rpmQVKArguments_s::installInterfaceFlags, rpmQVKArguments_s::no_rollback_links, rpmQVKArguments_s::probFilter, rpmQVKArguments_s::rbtid, rpmdbRemove(), rpmExpand(), rpmExpandNumeric(), rpmlog(), RPMLOG_ERR, RPMLOG_NOTICE, RPMRC_OK, rpmRollback(), rpmteNEVRA(), RPMTRANS_FLAG_DIRSTASH, RPMTRANS_FLAG_NOFDIGESTS, RPMTRANS_FLAG_REPACKAGE, RPMTRANS_TYPE_AUTOROLLBACK, RPMTRANS_TYPE_ROLLBACK, rpmtsARBGoal(), rpmtsDFlags(), rpmtsEmpty(), rpmtsFlags(), rpmtsGetRdb(), rpmtsGetTid(), rpmtsiFree(), rpmtsiInit(), rpmtsiNext(), rpmtsOpenDB(), rpmtsSetFlags(), rpmtsSetVSFlags(), rpmtsType(), RPMVSF_NEEDPAYLOAD, RPMVSF_NOHDRCHK, TR_REMOVED, rpmQVKArguments_s::transFlags, Unlink(), and vsflags.

Referenced by rpmtsCheck(), rpmtsOrder(), and rpmtsRun().

const char* rpmtsRootDir | ( | rpmts | ts | ) |

Get transaction rootDir, i.e.

path to chroot(2).

Parameters

  ts | transaction set

Returns
  transaction rootDir

Definition at line 817 of file rpmts.c.

References URL_IS_DASH, URL_IS_FTP, URL_IS_HKP, URL_IS_HTTP, URL_IS_HTTPS, URL_IS_PATH, URL_IS_UNKNOWN, and urlPath().

Referenced by createDir(), rpmfiNew(), rpmpsmStage(), rpmtsRun(), rpmVerifyFile(), and runScript().

int rpmtsRun | ( | rpmts | ts,
|  | rpmps | okProbs,
|  | rpmprobFilterFlags | ignoreSet
| ) |  |

Process all package elements in a transaction set.

Before calling rpmtsRun be sure to have:

- setup the rpm root dir via rpmtsSetRootDir().
- setup the rpm notify callback via rpmtsSetNotifyCallback().
- setup the rpm transaction flags via rpmtsSetFlags().

Additionally, though not required you may want to:

- setup the rpm verify signature flags via rpmtsSetVSFlags().

Parameters

  ts | transaction set
  okProbs | previously known problems (or NULL)
  ignoreSet | bits to filter problem types

Returns
  0 on success, -1 on error, >0 with newProbs set

Definition at line 1162 of file transaction.c.

References _, _free(), _noTransScripts, _noTransTriggers, Chdir(), Chroot(), currentDirectory(), D_, dbiFreeIndexSet(), dbiIndexRecordFileNumber(), dbiIndexRecordOffset(), dbiIndexSetCount(), ensureOlder(), FA_CREATE, rpmpsm_s::fi, rpmpsm_s::flags, fpCacheCreate(), fpCacheFree(), fpEqual(), fpHashFunction(), fpLookupList(), handleInstInstalledFiles(), handleOverlappedFiles(), handleRmvdInstalledFiles(), headerFree(), htAddEntry(), htCreate(), htFree(), IOSM_ALL_HARDLINKS, IOSM_MAP_ABSOLUTE, IOSM_MAP_ADDDOT, IOSM_SBIT_CHECK, iosmFileActionSkipped(), Lstat(), markLinkedFailed(), matchpathcon_fini, matchpathcon_init, rpmpsm_s::progTag, PSM_PKGERASE, PSM_PKGINSTALL, PSM_PKGSAVE, PSM_SCRIPT, RPMCALLBACK_INST_CLOSE_FILE, RPMCALLBACK_INST_OPEN_FILE, RPMCALLBACK_REPACKAGE_PROGRESS, RPMCALLBACK_REPACKAGE_START, RPMCALLBACK_REPACKAGE_STOP, RPMCALLBACK_TRANS_PROGRESS, RPMCALLBACK_TRANS_START, RPMCALLBACK_TRANS_STOP, rpmdbCheckSignals(), rpmdbFindFpList(), rpmdbOpenAll(), rpmdbSync(), rpmExpandNumeric(), rpmfiFC(), rpmfiFFlags(), rpmfiFN(), rpmfiFree(), rpmfiInit(), RPMFILE_CONFIG, RPMFILE_EXISTS, RPMFILE_SPARSE, rpmfiLink(), rpmfiNew(), rpmfiNext(), rpmfiSetFFlags(), rpmGetPath(), rpmlog(), RPMLOG_DEBUG, RPMLOG_ERR, rpmmiAddPattern(), rpmmiFree(), rpmmiNext(), RPMMIRE_STRCMP, RPMPROB_FILTER_OLDPACKAGE, RPMPROB_FILTER_REPLACEOLDFILES, RPMPROB_FILTER_REPLACEPKG, RPMPROB_PKG_INSTALLED, rpmpsAppend(), rpmpsFree(), RPMPSM_FLAGS_UNORDERED, rpmpsmFree(), rpmpsmNew(), rpmpsmStage(), rpmpsNumProblems(), rpmpsTrim(), RPMRC_NOKEY, RPMRC_NOTTRUSTED, RPMRC_OK, rpmReadPackageFile(), rpmswEnter(), rpmswExit(), RPMTAG_ARCH, RPMTAG_BASENAMES, RPMTAG_DISTEPOCH, RPMTAG_EPOCH, RPMTAG_NAME, RPMTAG_OS, RPMTAG_POSTTRANS, RPMTAG_POSTTRANSPROG, RPMTAG_PRETRANS, RPMTAG_PRETRANSPROG, RPMTAG_RELEASE, RPMTAG_VERSION, rpmteA(), rpmteAddedKey(), rpmteColor(), rpmteDBOffset(), rpmteE(), rpmteFd(), rpmteIsSource(), rpmteKey(), rpmteN(), rpmteNEVR(), rpmteO(), rpmteR(), rpmteType(), rpmteV(), RPMTRANS_FLAG_BUILD_PROBS, RPMTRANS_FLAG_DIRSTASH, RPMTRANS_FLAG_JUSTDB, RPMTRANS_FLAG_NOCONTEXTS, RPMTRANS_FLAG_NOPOSTTRANS, RPMTRANS_FLAG_NOPRETRANS, RPMTRANS_FLAG_NOSCRIPTS, RPMTRANS_FLAG_NOTRIGGERS, RPMTRANS_FLAG_REPACKAGE, RPMTRANS_FLAG_TEST, RPMTRANS_TYPE_AUTOROLLBACK, RPMTRANS_TYPE_ROLLBACK, RPMTS_OP_ERASE, RPMTS_OP_FINGERPRINT, RPMTS_OP_INSTALL, RPMTS_OP_REPACKAGE, rpmtsCheckDSIProblems(), rpmtsChrootDone(), rpmtsColor(), rpmtsCurrDir(), rpmtsFilterFlags(), rpmtsFlags(), rpmtsGetRdb(), rpmtsiFi(), rpmtsiFree(), rpmtsiInit(), rpmtsiNext(), rpmtsInitDSI(), rpmtsInitIterator(), rpmtsiOc(), rpmtsNElements(), rpmtsNotify(), rpmtsOp(), rpmtsOpenDB(), rpmtsProblems(), rpmtsRollback(), rpmtsRootDir(), rpmtsSELinuxEnabled(), rpmtsSetChrootDone(), rpmtsSetCurrDir(), rpmtsSetFlags(), rpmtsSetRelocateElement(), rpmtsSetTid(), rpmtsSetVSFlags(), rpmtsType(), rpmtsUnorderedSuccessors(), rpmtsVSFlags(), RPMVSF_NEEDPAYLOAD, rpmpsm_s::scriptTag, sharedCmp(), skipFiles(), rpmpsm_s::stepName, TR_ADDED, TR_REMOVED, vsflags, xcalloc(), and xmalloc().

Referenced by rpmcliInstallRun(), and rpmts_Run().

int rpmtsSELinuxEnabled | ( | rpmts | ts | ) |

Get selinuxEnabled flag, i.e.

is SE linux enabled?

Parameters

  ts | transaction set

Returns
  selinuxEnabled flag

Definition at line 912 of file rpmts.c.

Referenced by rpmtsFlags(), rpmtsRun(), rpmtsSetFlags(), and runScript().

void rpmtsSetARBGoal | ( | rpmts | ts,
|  | rpmuint32_t | goal
| ) |  |

Set autorollback goal.

Parameters

  ts | transaction set
  goal | autorollback goal

Definition at line 800 of file rpmts.c.

Referenced by rpmcliInstall(), and rpmErase().

int rpmtsSetChrootDone | ( | rpmts | ts,
|  | int | chrootDone
| ) |  |

Set chrootDone flag, i.e.

has chroot(2) been performed?

Parameters

  ts | transaction set
  chrootDone | new chrootDone flag

Returns
  previous chrootDone flag

Definition at line 925 of file rpmts.c.

Referenced by rpmpsmStage(), and rpmtsRun().

rpmuint32_t rpmtsSetColor | ( | rpmts | ts,
|  | rpmuint32_t | color
| ) |  |

Set color bits of transaction set.

Parameters

  ts | transaction set
  color | new color bits

Returns
  previous color bits

Definition at line 1350 of file rpmts.c.

Referenced by rpmts_SetColor().

void rpmtsSetCurrDir | ( | rpmts | ts,
|  | const char * | currDir
| ) |  |

Set transaction currDir, i.e.

current directory before chroot(2).

Parameters

  ts | transaction set
  currDir | new transaction currDir (or NULL)

Definition at line 875 of file rpmts.c.

References _free(), and xstrdup().

Referenced by rpmtsRun().

int rpmtsSetDBMode | ( | rpmts | ts,
|  | int | dbmode
| ) |  |

Set dbmode of transaction set.

Parameters

  ts | transaction set
  dbmode | new dbmode

Returns
  previous dbmode

Definition at line 1335 of file rpmts.c.

Referenced by rpmts_CloseDB(), and rpmts_OpenDB().

rpmdepFlags rpmtsSetDFlags | ( | rpmts | ts,
|  | rpmdepFlags | depFlags
| ) |  |

Set dependency flags, i.e.

bits that control rpmtsCheck() and rpmtsOrder().

Parameters

  ts | transaction set
  depFlags | new dependency flags

Returns
  previous dependency flags

Definition at line 1273 of file rpmts.c.

Referenced by rpmcliInstall(), rpmcliQuery(), rpmcliVerify(), rpmErase(), rpmgiNext(), rpmRollback(), and rpmts_SetDFlags().

rpmtransFlags rpmtsSetFlags | ( | rpmts | ts,
|  | rpmtransFlags | transFlags
| ) |  |

Set transaction flags, i.e.

bits that control rpmtsRun().

Parameters

  ts | transaction set
  transFlags | new transaction flags

Returns
  previous transaction flags

Definition at line 1254 of file rpmts.c.

References RPMTRANS_FLAG_NOCONTEXTS, and rpmtsSELinuxEnabled().

Referenced by rpmcliInstall(), rpmcliQuery(), rpmcliVerify(), rpmErase(), rpmRollback(), rpmts_Rollback(), rpmts_SetFlags(), rpmtsRollback(), and rpmtsRun().

tsmStage rpmtsSetGoal | ( | rpmts | ts,
|  | tsmStage | goal
| ) |  |

Set goal of transaction set.

Parameters

  ts | transaction set
  goal | new goal

Returns
  previous goal

Definition at line 1320 of file rpmts.c.

References TSM_UNKNOWN.

Referenced by rpmcliInstall(), rpmErase(), and rpmgiNext().

int rpmtsSetKeyring | ( | rpmts | ts,
|  | void * | _keyring
| ) |  |

Set transaction keyring.

Parameters

  ts | transaction set
  _keyring | new transaction keyring

Returns
  0 on success

Definition at line 723 of file rpmts.c.

References rpmtsGetRdb().

int rpmtsSetNotifyCallback | ( | rpmts | ts,
|  | rpmCallbackFunction | notify,
|  | rpmCallbackData | notifyData
| ) |  |

Set transaction notify callback function and argument.

Warning
  This call must be made before rpmtsRun() for install/upgrade/freshen to function correctly.

Parameters

  ts | transaction set
  notify | progress callback
  notifyData | progress callback private data

Returns
  0 on success

Definition at line 1365 of file rpmts.c.

Referenced by rpmcliInstall(), rpmErase(), rpmRollback(), and rpmts_Run().

rpmte rpmtsSetRelocateElement | ( | rpmts | ts,
|  | rpmte | relocateElement
| ) |  |

Set current relocate transaction element.

Parameters

  ts | transaction set
  relocateElement | new relocate transaction element

Returns
  previous relocate transaction element

Definition at line 1306 of file rpmts.c.

Referenced by addTE(), and rpmtsRun().

void rpmtsSetRootDir | ( | rpmts | ts,
|  | const char * | rootDir
| ) |  |

Set transaction rootDir, i.e.

path to chroot(2).

Parameters

  ts | transaction set
  rootDir | new transaction rootDir (or NULL)

Definition at line 840 of file rpmts.c.

References _free(), alloca(), stpcpy(), and xstrdup().

Referenced by main(), and rpmts_new().

int rpmtsSetSolveCallback | ( | rpmts | ts,
|  | int(*)(rpmts ts, rpmds ds, const void *data) | solve,
|  | const void * | solveData
| ) |  |

Set dependency solver callback.

Parameters

  ts | transaction set
  (*solve) | dependency solver callback
  solveData | dependency solver callback data (opaque)

Returns
  0 on success

Spec rpmtsSetSpec | ( | rpmts | ts,
|  | Spec | spec
| ) |  |

Set a spec control structure in transaction set.

Parameters

  ts | transaction set
  spec | new spec control structure

Returns
  previous spec control structure

Definition at line 1290 of file rpmts.c.

Referenced by _specQuery(), and parseSpec().

rpmuint32_t rpmtsSetTid | ( | rpmts | ts,
|  | rpmuint32_t | tid
| ) |  |

Set transaction id, i.e.

transaction time stamp.

Parameters

  ts | transaction set
  tid | new transaction id

Returns
  previous transaction id

Definition at line 946 of file rpmts.c.

Referenced by main(), and rpmtsRun().

void rpmtsSetType | ( | rpmts | ts,
|  | rpmTSType | type
| ) |  |

Set transaction type.

Allowed types are: RPMTRANS_TYPE_NORMAL RPMTRANS_TYPE_ROLLBACK RPMTRANS_TYPE_AUTOROLLBACK

Parameters

  ts | transaction set
  type | transaction type

Definition at line 789 of file rpmts.c.

Referenced by rpmRollback().

rpmVSFlags rpmtsSetVSFlags | ( | rpmts | ts,
|  | rpmVSFlags | vsflags
| ) |  |

Set verify signatures flag(s).

Parameters

  ts | transaction set
  vsflags | new verify signatures flags

Returns
  previous value

Definition at line 759 of file rpmts.c.

References pgpDigVSFlags, and vsflags.

Referenced by main(), rpmcliInstall(), rpmcliQuery(), rpmcliVerify(), rpmErase(), rpmInstallSource(), rpmRollback(), rpmts_new(), rpmts_SetVSFlags(), rpmtsRollback(), and rpmtsRun().

int rpmtsSolve | ( | rpmts | ts,
|  | rpmds | ds,
|  | const void * | data
| ) |  |

Attempt to solve a needed dependency using the solve database.

Parameters

  ts | transaction set
  ds | dependency set
  data | opaque data associated with callback

Returns
  -1 retry, 0 ignore, 1 not found

Definition at line 302 of file rpmts.c.

References _, _free(), alloca(), D_, Fclose(), Ferror(), Fopen(), Fstrerror(), headerFree(), headerGet(), headerLink(), headerSprintf(), _HE_s::p, rpmDataType_u::ptr, RPMDEPS_FLAG_ADDINDEPS, rpmdsAnyMatchesDep(), rpmdsN(), rpmdsTagN(), rpmExpand(), rpmHeaderFormats, rpmlog(), RPMLOG_DEBUG, RPMLOG_ERR, rpmmiFree(), rpmmiInit(), rpmmiNext(), RPMRC_NOKEY, RPMRC_NOTTRUSTED, RPMRC_OK, rpmReadPackageFile(), RPMTAG_BASENAMES, RPMTAG_BUILDTIME, RPMTAG_CONFLICTNAME, RPMTAG_DIRNAMES, RPMTAG_FILELINKTOS, RPMTAG_NAME, RPMTAG_PROVIDENAME, RPMTAG_REQUIRENAME, rpmtsAddInstallElement(), rpmtsOpenSDB(), rpmDataType_u::str, sugcmp(), _HE_s::tag, TSM_INSTALL, rpmDataType_u::ui32p, and xrealloc().

Referenced by rpmts_Check(), and rpmtsCreate().

Spec rpmtsSpec | ( | rpmts | ts | ) |

Get spec control structure from transaction set.

Parameters

  ts | transaction set

Returns
  spec control structure

Definition at line 1283 of file rpmts.c.

Referenced by spec_Parse().

rpmTSType rpmtsType | ( | rpmts | ts | ) |

Return the type of a transaction.

Parameters

  ts | transaction set

Returns
  transaction type, 0 on unknown

Definition at line 784 of file rpmts.c.

Referenced by populateInstallHeader(), rpmpsmStage(), rpmtsRollback(), and rpmtsRun().

rpmts rpmtsUnlink | ( | rpmts | ts,
|  | const char * | msg
| ) |  |

Unreference a transaction instance.

Parameters

  ts | transaction set
  msg |

Returns
  NULL on last dereference

int rpmtsUnorderedSuccessors | ( | rpmts | ts,
|  | int | first
| ) |  |

Set index of 1st element of successors.

Parameters

  ts | transaction set
  first | new index of 1st element of successors

Returns
  previous value

Definition at line 806 of file rpmts.c.

Referenced by rpmtsOrder(), and rpmtsRun().

void rpmtsUpdateDSI | ( | const rpmts | ts,
|  | dev_t | dev,
|  | rpmuint32_t | fileSize,
|  | rpmuint32_t | prevSize,
|  | rpmuint32_t | fixupSize,
|  | int | _action
| ) |  |

Update disk space info for a file.

Parameters

  ts | transaction set
  dev | mount point device
  fileSize | file size
  prevSize | previous file size (if upgrading)
  fixupSize | size difference (if
  _action | file disposition

Definition at line 1094 of file rpmts.c.

References FA_ALTNAME, FA_BACKUP, FA_CREATE, FA_ERASE, and FA_SAVE.

Referenced by handleOverlappedFiles().

int rpmtsVerifyDB | ( | rpmts | ts | ) |

Verify the database used by the transaction.

Parameters

  ts | transaction set

Returns
  0 on success

Definition at line 152 of file rpmts.c.

References rpmdbVerify().

Referenced by main(), and rpmts_VerifyDB().

rpmVSFlags rpmtsVSFlags | ( | rpmts | ts | ) |

Get verify signatures flag(s).

Parameters

  ts | transaction set

Returns
  verify signatures flags

Definition at line 754 of file rpmts.c.

References pgpDigVSFlags.

Referenced by ftsCacheUpdate(), rpmInstallSource(), rpmpsmStage(), rpmts_GetVSFlags(), rpmts_HdrCheck(), rpmtsInitIterator(), rpmtsRebuildDB(), and rpmtsRun().